; ***********************************************
; *                   OneDayPulse               *
; ***********************************************
; *                                             *
; *   Gomb 7-es lb s a fld kz kell ktni   *
; *   Rel kimenet 5-s lb                     *
; *                                             *
; ***********************************************

list p=p12F508 r=DEC
#include <p12F508.inc> 

__CONFIG   _MCLRE_OFF & _CP_OFF & _WDT_OFF & _XT_OSC

; Konstansok

BUTTON                  equ     .0              ;Gomb a GPIO0
RELAY                   equ     .2              ;Rel a GPIO2
C_DAY_H                 equ     0x02            ;24 ra = 172800 * 0,5s         
C_DAY_M                 equ     0xa2            ;Ez a 3 byte 172800-1
C_DAY_L                 equ     0xff
MSB                     equ     .7              ;Legnagyobb bit rtke

; Vltozk

TMR_CNT_H               equ     0x07            ;Az 500ms-hoz szksges szmll
TMR_CNT_M               equ     0x08
TMR_CNT_L               equ     0x09
DAY_CNT_H               equ     0x0a            ;Az egy nap szmllja
DAY_CNT_M               equ     0x0b
DAY_CNT_L               equ     0x0c
FLAGS                   equ     0x0d            ;tmeneti trol a klnbz esemnyek jelzsre
REL_CNT                 equ     0x0e            ;A rel kimenet magas szintjnek szmllja

; Program
                        org     .0              ;Reset utni els felhasznli utasts cme
                        
                        clrf    GPIO            ;Kimeneti trol trlse
                        movlw   B'11111011'     ;GPIO2 kimenet a tbbi bemenet
                        tris    GPIO            
                        movlw   B'10000000'     ;Szmll, eloszt, bels felhzellenllsok belltsa
                        option
                        clrf    FLAGS           ;Regiszterek alaphelyzetbe lltsa
                        clrf    TMR0
                        movlw   0x07
                        movwf   TMR_CNT_H       ;500ms-os idzt szmlljnak belltsa
                        movlw   0xa2            ;500 000 >> hexa 07 A1 20  
                        movwf   TMR_CNT_M       ;A kzpsbjt +1-re lltva kis kompenzls az els ciklusnak
                        movlw   0x20
                        movwf   TMR_CNT_L
main                                            ;Fciklus
                        btfsc   FLAGS,RELAY     ;Be kell kapcsolni a relt?
                        goto    ron             ;ha igen ugrs
                        bcf     GPIO,RELAY      ;ha nem kimenet 0-ba
                        goto    butt            ;Ugrs a gomb ellenrzsre
ron
                        bsf     GPIO,RELAY      ;Kimenet 1-be
butt                                            ;Gomb ellenrzse
                        btfsc   GPIO,BUTTON     ;Lenyomtk a gombot?
                        goto    check           ;Ha nem TMR ellenrzse
                        movlw   C_DAY_H         ;24 ra innen indul
                        movwf   DAY_CNT_H
                        movlw   C_DAY_M
                        movwf   DAY_CNT_M
                        movlw   C_DAY_L
                        movwf   DAY_CNT_L
                        bsf     FLAGS,RELAY     ;Rel be
                        movlw   .3              ;3*500ms-ig
                        movwf   REL_CNT
check                                           ;A TMR0 legmagasabb bitjnek ellenrzse ezzel max 256 urasts lehet a ciklus eltt s utn
                        btfsc   TMR0,MSB        ;Csak a legmagasabb bit vltsra vagyunk kvncsiak
                        goto    msb_h
                        btfss   FLAGS,MSB       ;Bit alacsony s nem vltozott
                        goto    main            ;Vissza a fciklus elejre
                        bcf     FLAGS,MSB       ;Ha vltozott a jelz tlltsa
                        goto    sub             ;500ms szmllra ugrs 
msb_h
                        btfsc   FLAGS,MSB       ;TMR0 legmagasabb bitje 1 volt s nem vltozott
                        goto    main            ;vissza a fciklus elejre
                        bsf     FLAGS,MSB       ;Ha vltozott a jelz tlltsa 
sub
                        movf    TMR_CNT_M,F     ;0 e szmll kzps bjtja
                        btfsc   STATUS,Z
                        decf    TMR_CNT_H,F     ;Ha nulla volt a fels byte cskkentse
                        decfsz  TMR_CNT_M,F     ;Kzps byte cskkents
                        goto    main            ;Ha nem 0 vissza a fciklusra
                        movf    TMR_CNT_H,F     ;Ha 0 a fels byte ellenrzse
                        btfss   STATUS,Z
                        goto    main            ;Ha nem nulla vissza a fciklusra
                        movlw   0x07            ;Ha nulla letelt az 500 ms
                        movwf   TMR_CNT_H       ;Szmllk visszalltsa
                        movlw   0xa1
                        movwf   TMR_CNT_M
                        movlw   0x20            ;Az als byte kompenzlsa, mivel a ciklus ezt nem tudja nzi
                        addwf   TMR_CNT_L,F     ;A felhalmozdsval kompenzlja a kzps bjtot
                        btfsc   STATUS,C
                        incf    TMR_CNT_M,F
                    
                        btfss   FLAGS,RELAY     ;Be van kapcsolva a rel
                        goto    daytime         ;Nem csak a 24 ra cskkentse
                        decfsz  REL_CNT         ;Letelt 1,5s ?
                        goto    daytime         ;Nem csak a 24 ra cskkentse
                        bcf     FLAGS,RELAY     ;Letelt a 1,5s rel ki!
 daytime
                        movlw   .1              ;Szmll cskkentse
                        subwf   DAY_CNT_L,F        
                        btfss   STATUS,C       
                        subwf   DAY_CNT_M,F        
                        btfss   STATUS,C       
                        subwf   DAY_CNT_H,F
                        btfsc   STATUS,C  
                        goto    main            ;Amikor 0-bol levonja az 1-et eltelt 24 ra
                        movlw   C_DAY_H         ;Szmll visszalltsa
                        movwf   DAY_CNT_H
                        movlw   C_DAY_M
                        movwf   DAY_CNT_M
                        movlw   C_DAY_L
                        movwf   DAY_CNT_L
                        bsf     FLAGS,RELAY     ;Rel be
                        movlw   .3              ;1,5s-ig
                        movwf   REL_CNT
                        goto    main            ;vissza a fciklusra
                        
 END                                  